﻿using System.Collections.Generic;
using HeuristicLab.Core;
using HeuristicLab.Random;

namespace HeuristicLab.BenchmarkSuite
{
    public abstract class BenchmarkSuiteDataDescritpor<T> : ArtificialDataDescriptor
    {
        protected static IRandom rand = new FastRandom();

        protected abstract IEnumerable<T> GenerateTraining();
        protected abstract IEnumerable<T> GenerateTest();

        protected abstract IEnumerable<Example> GenerateExamples(IEnumerable<T> trainingAndTest);

        protected override IEnumerable<Example> GenerateExamples()
        {
            var training = GenerateTraining();

            training = training.Shuffle(rand);

            var test = GenerateTest();

            var all = new List<T>();
            all.AddRange(training);
            all.AddRange(test);

            return GenerateExamples(all);
        }
    }
}
